/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#if !defined(AFX_FILTERDLG_H__E8461F03_51A4_11D4_BDBE_00C04F89E392__INCLUDED_)
#define AFX_FILTERDLG_H__E8461F03_51A4_11D4_BDBE_00C04F89E392__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// FilterDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CFilterDlg dialog

class CFilterDlg : public CDialog
{
    // Construction
public:
    CFilterDlg(CWnd* pParent = NULL);   // standard constructor

    // Dialog Data
    //{{AFX_DATA(CFilterDlg)
    enum { IDD = IDD_FILTER_DLG };
    CComboBox   m_ctlUsers;
    CComboBox   m_ctlProjects;
    CComboBox   m_ctlInjectors;
    //}}AFX_DATA

    void SetInjectors(const CStringArray& arstrInjectors);
    void SetUsers(const CStringArray& arstrUsers);
    void SetProjects(const CStringArray& arstrProjects);

    void SetSelectedInjector(const CString& strInjector)
    {
        m_strSelectedInjector = strInjector;
    }
    void SetSelectedUser(const CString& strUser)
    {
        m_strSelectedUser = strUser;
    }
    void SetSelectedProject(const CString& strProject)
    {
        m_strSelectedProject = strProject;
    }

    CString GetSelectedInjector()
    {
        return m_strSelectedInjector;
    }
    CString GetSelectedUser()
    {
        return m_strSelectedUser;
    }
    CString GetSelectedProject()
    {
        return m_strSelectedProject;
    }
    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CFilterDlg)
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

    // Implementation
protected:
    CString m_szHtmlHelpFile;
    CString m_strSelectedInjector;
    CString m_strSelectedUser;
    CString m_strSelectedProject;

    CStringArray m_arstrInjectors;
    CStringArray m_arstrUsers;
    CStringArray m_arstrProjects;
    // Generated message map functions
    //{{AFX_MSG(CFilterDlg)
    virtual BOOL OnInitDialog();
    virtual void OnOK();
    afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
    afx_msg void OnFullHelp();
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FILTERDLG_H__E8461F03_51A4_11D4_BDBE_00C04F89E392__INCLUDED_)
