/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// EditorSheet.cpp : implementation file
//

#include "stdafx.h"
#include "xotaeditor.h"
#include "EditorSheet.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditorSheet// Handle to the Windows Message hook
HHOOK g_hHook = NULL;

IMPLEMENT_DYNAMIC(CEditorSheet, CPropertySheet)

CEditorSheet::CEditorSheet()
        :CPropertySheet()
{}


CEditorSheet::CEditorSheet(UINT nIDCaption, CWnd* pParentWnd, UINT iSelectPage)
        :CPropertySheet(nIDCaption, pParentWnd, iSelectPage)
{}


CEditorSheet::CEditorSheet(LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage)
        :CPropertySheet(pszCaption, pParentWnd, iSelectPage)
{}


CEditorSheet::~CEditorSheet()
{}



BEGIN_MESSAGE_MAP(CEditorSheet, CPropertySheet)
//{{AFX_MSG_MAP(CEditorSheet)
ON_WM_SIZE()
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditorSheet message handlers

void CEditorSheet::OnSize(UINT nType, int cx, int cy)
{
    CPropertySheet::OnSize(nType, cx, cy);

    CTabCtrl *pTabCtrl = GetTabControl();
    if(pTabCtrl!=NULL)
    {
        pTabCtrl->MoveWindow(0,0,cx,cy);

        CPropertyPage *pPage =GetActivePage();
        if(pPage != NULL)
        {
            SetActivePage(pPage);
            pPage->Invalidate();
        }
    }
}

BOOL CEditorSheet::Create( CWnd* pParentWnd,DWORD dwStyle,DWORD dwExStyle)
{
    //add pages this way so that they match the enum order
    /*   NO_SQL
        int nPage=0;
        while(1)
        {
            switch(nPage++)
            {
            case enOptionsPage:         AddPage(&m_OptionsPage);        break;
            case enEnvironmentPage:     AddPage(&m_EnvironmentPage);    break;
            case enTargetPage:          AddPage(&m_TargetPage);         break;
            case enSimpleQueryPage:     AddPage(&m_SimpleQueryPage);    break;
            case enDetailedQueryPage:   AddPage(&m_DetailedQueryPage);  break;
            default:
                return CPropertySheet::Create(pParentWnd,dwStyle,dwExStyle);
            break;
            }
        }
    */
    AddPage(&m_SimpleQueryPage);
    return CPropertySheet::Create(pParentWnd,dwStyle,dwExStyle);
}

void CEditorSheet::AddDataEntry(const CString strRecordName,const CStringArray& arstrParams)
{
    int nNumPages = GetPageCount();
    for(int nPage=0;nPage<nNumPages;nPage++)
    {
        CGenericPage *pPage = dynamic_cast<CGenericPage*>(GetPage(nPage));
        if(pPage!=NULL)
        {
            if(pPage->GetTokenName()==strRecordName)
            {
                pPage->AddDataEntry(arstrParams);
            }
        }
    }
}

BOOL CEditorSheet::OnInitDialog()
{
    ModifyStyleEx (0, WS_EX_CONTROLPARENT);

    BOOL bResult = CPropertySheet::OnInitDialog();

    return bResult;
}

BOOL CEditorSheet::PreTranslateMessage(MSG* pMsg)
{
    CGenericPage *pPage = dynamic_cast<CGenericPage*>(GetActivePage());

    if (pPage->PreTranslateMessage(pMsg))
        return true;

    return CPropertySheet::PreTranslateMessage(pMsg);
}
