/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// ListOutputDlg.cpp : implementation file
//

#include "stdafx.h"
#include "xotaeditor.h"
#include "ListOutputDlg.h"
#include "..\..\HTMLHelp\XOTAEditor\Query_Test.inl"
#include "htmlhelp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CListOutputDlg dialog


CListOutputDlg::CListOutputDlg(CWnd* pParent /*=NULL*/)
        : CDialog(CListOutputDlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(CListOutputDlg)
    m_strList = _T("");
    //}}AFX_DATA_INIT

    m_szHtmlHelpFile = getenv("CYRANO_HOME");
    m_szHtmlHelpFile += "\\Framework\\Help\\Commander.chm";
}


void CListOutputDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CListOutputDlg)
    DDX_Text(pDX, IDC_LIST, m_strList);
    //}}AFX_DATA_MAP
}



BEGIN_MESSAGE_MAP(CListOutputDlg, CDialog)
//{{AFX_MSG_MAP(CListOutputDlg)
ON_WM_HELPINFO()
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CListOutputDlg message handlers
BOOL CListOutputDlg::AddString(const CString& str)
{
    m_strList += str;
    UpdateData(FALSE);
    return false;
}

void CListOutputDlg::ClearList()
{
    m_strList.Empty();
    UpdateData(FALSE);
}

BOOL CListOutputDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    return TRUE;  // return TRUE unless you set the focus to a control
    // EXCEPTION: OCX Property Pages should return FALSE
}


BOOL CListOutputDlg::OnHelpInfo(HELPINFO* pHelpInfo)
{
    CString contextHelp = m_szHtmlHelpFile+"::whatisthis.txt";

    if (pHelpInfo->iCtrlId == IDC_STATIC)
        return true;

    CWnd* pWnd = GetDlgItem(pHelpInfo->iCtrlId);

	if(pWnd)
	    HtmlHelp(pWnd->m_hWnd, contextHelp, HH_TP_HELP_CONTEXTMENU, (DWORD)(LPVOID)g_TopicIdArray);

    return true;
}
