/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// OptionsPage.cpp : implementation file
//

#include "stdafx.h"
#include "xotaeditor.h"
#include "OptionsPage.h"
#include "..\..\HTMLHelp\XOTAEditor\Options.inl"
#include "htmlhelp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COptionsPage property page

IMPLEMENT_DYNCREATE(COptionsPage, CPropertyPage)

COptionsPage::COptionsPage() : CGenericPage(COptionsPage::IDD)
{
    //{{AFX_DATA_INIT(COptionsPage)
    //}}AFX_DATA_INIT
    m_strTokenName = "Options";
    m_szHtmlHelpFile = getenv("CYRANO_HOME");
    m_szHtmlHelpFile += "\\Framework\\Help\\Commander.chm";
}

COptionsPage::~COptionsPage()
{}


void COptionsPage::DoDataExchange(CDataExchange* pDX)
{
    CPropertyPage::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(COptionsPage)
    DDX_Control(pDX, IDC_RETRIEVE_DETAILS, m_ctlRetrieveDetails);
    //}}AFX_DATA_MAP
}



BEGIN_MESSAGE_MAP(COptionsPage, CPropertyPage)
//{{AFX_MSG_MAP(COptionsPage)
ON_WM_SIZE()
ON_BN_CLICKED(IDCANCEL,OnCancel)
ON_BN_CLICKED(IDOK, OnOK)
ON_WM_DESTROY()
ON_WM_HELPINFO()
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptionsPage message handlers

void COptionsPage::OnSize(UINT nType, int cx, int cy)
{
    CPropertyPage::OnSize(nType, cx, cy);

    // TODO: Add your message handler code here
}


void COptionsPage::OnDestroy()
{
    CPropertyPage::OnDestroy();

    // TODO: Add your message handler code here

}


BOOL COptionsPage::OnInitDialog()
{
    CPropertyPage::OnInitDialog();

    int nNdx =-1;

    //fill retrieve details combo box
    nNdx = m_ctlRetrieveDetails.AddString("No");
    m_ctlRetrieveDetails.SetItemData(nNdx,enDetailsNo);

    nNdx = m_ctlRetrieveDetails.AddString("Yes");
    m_ctlRetrieveDetails.SetItemData(nNdx,enDetailsYes);
    m_ctlRetrieveDetails.SetCurSel(1);

    return false;//TRUE;  // return TRUE unless you set the focus to a control
    // EXCEPTION: OCX Property Pages should return FALSE
}


int COptionsPage::GetNumDataEntries()
{
    return 1;
}

bool COptionsPage::GetDataEntry(int nEntry,CStringArray& arstrParams)
{
    UpdateData(TRUE);
    if(nEntry!=0)
    {
        ASSERT(FALSE);
        return false;
    }

    CString strEntry;

    int nCurSel = m_ctlRetrieveDetails.GetCurSel();
    if(nCurSel!=CB_ERR)
    {
        strEntry.Format("%d",m_ctlRetrieveDetails.GetItemData(nCurSel));
        arstrParams.Add("DoDetails");
        arstrParams.Add(strEntry);
    }

    return true;
}

void COptionsPage::AddDataEntry(const CStringArray& arstrParams)
{
    CString strToken,strValue;
    int nNumEntries=arstrParams.GetSize()/2;
    for(int nEntry=0;nEntry<nNumEntries;nEntry++)
    {
        strToken = arstrParams[nEntry*2];
        strValue = arstrParams[nEntry*2+1];

        if(strToken == "DoDetails")
        {
            int nValue = atoi(strValue);
            int nNumItems = m_ctlRetrieveDetails.GetCount();
            for(int nItem=0;nItem<nNumItems;nItem++)
            {
                if((int)m_ctlRetrieveDetails.GetItemData(nItem)==nValue)
                {
                    m_ctlRetrieveDetails.SetCurSel(nItem);
                    break;
                }
            }

        }
        else
        {
            ASSERT(FALSE);
        }
    }
}

BOOL COptionsPage::OnHelpInfo(HELPINFO* pHelpInfo)
{
    CString contextHelp = m_szHtmlHelpFile+"::whatisthis.txt";

    if (pHelpInfo->iCtrlId == IDC_STATIC)
        return true;

    CWnd* pWnd = GetDlgItem(pHelpInfo->iCtrlId);

	if(pWnd)
	    HtmlHelp(pWnd->m_hWnd, contextHelp, HH_TP_HELP_CONTEXTMENU, (DWORD)(LPVOID)g_TopicIdArray);

    return true;
}
