/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

////////////////////////////////////////////////////////////////////////////////
// @doc     Document
// @module  CECProjectSelector 
//          XReposTree pages.
//
////////////////////////////////////////////////////////////////////////////////


//{{AFX_INCLUDES()
#include "xrepostree.h"
//}}AFX_INCLUDES
#if !defined(AFX_CECXFLOORDLG_H__8E709F7B_F8A3_11D2_BDC5_00608CB45114__INCLUDED_)
#define AFX_CECXFLOORDLG_H__8E709F7B_F8A3_11D2_BDC5_00608CB45114__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CECXFloorDlg.h : header file
//

class CYRServer;


#define WMU_EXECUTE_TEST        (WM_USER+7001)
#define WMU_OPEN_TESTRUN        (WM_USER+7002)
#define WMU_EDIT_FILE           (WM_USER+7003)
#define WMU_XVIEW_RESULTS       (WM_USER+7004)
#define WMU_NEW_TEST            (WM_USER+7006)
#define WMU_NEW_SCRIPT          (WM_USER+7007)
#define WMU_EXPORT_FILE         (WM_USER+7008)
#define WMU_OPEN_FILE           (WM_USER+7009)
#define WMU_HTTP_STATS          (WM_USER+7010)

/////////////////////////////////////////////////////////////////////////////
// CECXFloorDlg dialog
class CECXFloorDlg : public CDialog
{
    // Construction
public:
    void SetServer(CYRServer* pServer);
    void Refresh();
    void SetConfig(CString strConfig);
    CString GetTestName();
    CString GetScriptName();
    CECXFloorDlg(CWnd* pParent = NULL);   // standard constructor
    void ChangeProject(CString strProjName);
    void GetOpenTestRun(CString &TestName, CString &RunName);
    void EnableMenus(LPCTSTR strPage, BOOL bEnabled);
    // Dialog Data
    //{{AFX_DATA(CECXFloorDlg)
	enum { IDD = IDD_XFLOORDLG };
    CListCtrl   m_nodeList;
    CXReposTree m_OutputView;
    CXReposTree m_ProjectView;
    CXReposTree m_SourceView;
    CXReposTree m_TestView;
	//}}AFX_DATA

	CBCGOutlookBar m_wndBarOutlook;

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CECXFloorDlg)
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

    // Implementation
protected:
    afx_msg void OnContextMenu(CWnd*, CPoint point);

    // Generated message map functions
    //{{AFX_MSG(CECXFloorDlg)
    afx_msg void OnSize(UINT nType, int cx, int cy);
    virtual BOOL OnInitDialog();
    afx_msg void OnXInitiateTest(LPCTSTR strTestName);
    afx_msg void OnXOpenTestRun(LPCTSTR TestName, LPCTSTR TestRunName);
    afx_msg void OnXEditFile(LPCTSTR strFileName);
    afx_msg void OnXAddTest();
    afx_msg void OnXAddScript();
    afx_msg void OnXExportFile(LPCTSTR strFileName);
    afx_msg void OnXOpenFile(LPCTSTR strFileName);
    afx_msg void OnXViewResults(LPCTSTR strTestName, LPCTSTR strTestRunName, short nType);
    afx_msg void OnDblclkNodelist(NMHDR* pNMHDR, LRESULT* pResult);
    afx_msg void OnNodeDelete();
    afx_msg void OnNodeEdit();
    afx_msg void OnNodeNew();
    afx_msg void OnPaint();
    afx_msg void OnXViewHttpStatsXreposOutput(LPCTSTR TestName, LPCTSTR TestRunName);
    DECLARE_EVENTSINK_MAP()
    //}}AFX_MSG
    afx_msg BOOL OnEraseBkgnd(CDC *pDC);
    DECLARE_MESSAGE_MAP()
private:
    BOOL m_bShowNodeMenus;
    int m_nodePage;
    void FillNodeList();
    CString m_strTestToExecute;
    CString m_strScriptToEdit;
    CString m_OpenRun_Test;
    CString m_OpenRun_RunName;
    CString m_strConfig;
    CString m_strActiveProject;

    CImageList m_ImageList;
    CYRServer* m_pServer;
    int RetrieveHitItem();
    int m_selectedNode;

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CECXFLOORDLG_H__8E709F7B_F8A3_11D2_BDC5_00608CB45114__INCLUDED_)
