/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

/////////////////////////////////////////////////////////////////////////
//
// CXReposTree.h
// --------------
//
//    This is the include file for the CXReposTree class
//
//=========================================================================



//{{AFX_INCLUDES()
#include "xtree.h"
//}}AFX_INCLUDES
#if !defined(AFX_CXREPOSTREE1_H__06BCDA2C_DE1D_11D2_BCFC_00608CB45114__INCLUDED_)
#define AFX_CXREPOSTREE1_H__06BCDA2C_DE1D_11D2_BCFC_00608CB45114__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CXReposTree1.h : header file
//
#include "CXUserMsg.h"
class CYRServer;
/////////////////////////////////////////////////////////////////////////////
// CXReposTree dialog

class CXReposTree : public CDialog
{
    // Construction
public:
    void EnableMenus(BOOL bEnabaled);
    void RefreshTree();
    void Activate();
    CXReposTree(CWnd* pParent = NULL);   // standard constructor
    void AddProjects();
    void SetServer(CYRServer* pServer);
    // Dialog Data
    //{{AFX_DATA(CXReposTree)
    enum { IDD = IDD_REPOS_TREE };
    CXTree  m_XTreeRepos;
    //}}AFX_DATA


    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CXReposTree)
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

    // Implementation
protected:

    // Generated message map functions
    //{{AFX_MSG(CXReposTree)
    virtual BOOL OnInitDialog();
    afx_msg void OnSize(UINT nType, int cx, int cy);
    afx_msg void OnLBDblClickXtreeRepos(long hTreeItem, short nNodeType, LPCTSTR szPath);
    DECLARE_EVENTSINK_MAP()
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()

private:
    HTREEITEM m_CurrentItem;
    CString m_strActiveProject;
    CYRServer* m_pServer;

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CXREPOSTREE1_H__06BCDA2C_DE1D_11D2_BCFC_00608CB45114__INCLUDED_)
