// TestRunPropertiesDlg.cpp : implementation file
//

#include "stdafx.h"
#include "xrepostree.h"
#include "TestRunPropertiesDlg.h"
#include "Server.h"
#include "..\..\studio\common\TestWizardDefs.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTestRunPropertiesDlg dialog


CTestRunPropertiesDlg::CTestRunPropertiesDlg(CYRServer *pServer,const CString& strTest,const CString& strRun,CWnd* pParent /*=NULL*/)
	: CDialog(CTestRunPropertiesDlg::IDD, pParent)
{
	m_pServer = pServer;
	//{{AFX_DATA_INIT(CTestRunPropertiesDlg)
	m_strDescription = _T("");
	m_strIterations = _T("");
	m_strNumUsers = _T("");
	m_strRunName = strRun;
	m_strTestName = strTest;
	m_strTestType = _T("");
	//}}AFX_DATA_INIT
}


void CTestRunPropertiesDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestRunPropertiesDlg)
	DDX_Text(pDX, IDC_DESCRIPTION, m_strDescription);
	DDX_Text(pDX, IDC_NUM_ITERATIONS, m_strIterations);
	DDX_Text(pDX, IDC_NUM_USERS, m_strNumUsers);
	DDX_Text(pDX, IDC_RUN_NAME, m_strRunName);
	DDX_Text(pDX, IDC_TEST_NAME, m_strTestName);
	DDX_Text(pDX, IDC_TEST_TYPE, m_strTestType);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTestRunPropertiesDlg, CDialog)
	//{{AFX_MSG_MAP(CTestRunPropertiesDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestRunPropertiesDlg message handlers

BOOL CTestRunPropertiesDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	DWORD dwMaxBufferSize=50;

	CString strDataTip;
	CString strWizFile = m_pServer->GetFolderPath(CYRServer::enTestsFolder) + m_strTestName + "\\" + m_strRunName + "\\";
	strWizFile += m_strTestName + ".WIZ";

	GetPrivateProfileString(WIZARD_TEST,WIZARD_TEST_NUM_V_USERS,"Unknown",m_strNumUsers.GetBuffer(dwMaxBufferSize),dwMaxBufferSize,strWizFile);
	m_strNumUsers.ReleaseBuffer();

	GetPrivateProfileString(WIZARD_TEST,WIZARD_TEST_NUM_ITERATIONS,"Unknown",m_strIterations.GetBuffer(dwMaxBufferSize),dwMaxBufferSize,strWizFile);
	m_strIterations.ReleaseBuffer();

	GetPrivateProfileString(WIZARD_TEST,WIZARD_TEST_DESCRIPTION,"Unknown",m_strDescription.GetBuffer(dwMaxBufferSize),dwMaxBufferSize,strWizFile);
	m_strDescription.ReleaseBuffer();

	GetPrivateProfileString(WIZARD_TEST,WIZARD_TEST_TYPE,"Unknown",m_strTestType.GetBuffer(dwMaxBufferSize),dwMaxBufferSize,strWizFile);
	m_strTestType.ReleaseBuffer();

	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
