#if !defined(AFX_XTESTDYNAMICGRAPHSCTL_H__EA6B8D15_D24B_11D3_BD6F_00C04F89E392__INCLUDED_)
#define AFX_XTESTDYNAMICGRAPHSCTL_H__EA6B8D15_D24B_11D3_BD6F_00C04F89E392__INCLUDED_
/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// XTestDynamicGraphsCtl.h : Declaration of the CXTestDynamicGraphsCtrl ActiveX Control class.

/////////////////////////////////////////////////////////////////////////////
// CXTestDynamicGraphsCtrl : See XTestDynamicGraphsCtl.cpp for implementation.
#include "CECTestGraphDlg.h"

class CXTestDynamicGraphsCtrl : public COleControl
{
    DECLARE_DYNCREATE(CXTestDynamicGraphsCtrl)

    // Constructor
public:
    CXTestDynamicGraphsCtrl();

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CXTestDynamicGraphsCtrl)
public:
    virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
    virtual void DoPropExchange(CPropExchange* pPX);
    virtual void OnResetState();
    virtual BOOL PreTranslateMessage(MSG* pMsg);
    //}}AFX_VIRTUAL

    // Implementation
protected:
    ~CXTestDynamicGraphsCtrl();

    DECLARE_OLECREATE_EX(CXTestDynamicGraphsCtrl)    // Class factory and guid
    DECLARE_OLETYPELIB(CXTestDynamicGraphsCtrl)      // GetTypeInfo
    DECLARE_PROPPAGEIDS(CXTestDynamicGraphsCtrl)     // Property page IDs
    DECLARE_OLECTLTYPE(CXTestDynamicGraphsCtrl)     // Type name and misc status

    // Message maps
    //{{AFX_MSG(CXTestDynamicGraphsCtrl)
    afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
    afx_msg void OnSize(UINT nType, int cx, int cy);
    afx_msg void OnDestroy();
    afx_msg BOOL OnEraseBkgnd(CDC* pDC);
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()

    // Dispatch maps
    //{{AFX_DISPATCH(CXTestDynamicGraphsCtrl)
    afx_msg void XInitialize(LPCTSTR strManagerRegName, LPCTSTR strInjector);
    //}}AFX_DISPATCH
    DECLARE_DISPATCH_MAP()

    // Event maps
    //{{AFX_EVENT(CXTestDynamicGraphsCtrl)
    void FireControlClosing()
    {
        FireEvent(eventidControlClosing,EVENT_PARAM(VTS_NONE));
    }
    //}}AFX_EVENT
    DECLARE_EVENT_MAP()

    // Dispatch and event IDs
public:
    enum {
        //{{AFX_DISP_ID(CXTestDynamicGraphsCtrl)
        dispidXInitialize = 1L,
        eventidControlClosing = 1L,
        //}}AFX_DISP_ID
    };

protected:
    CECTestGraphDlg m_TestGraphDlg;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_XTESTDYNAMICGRAPHSCTL_H__EA6B8D15_D24B_11D3_BD6F_00C04F89E392__INCLUDED)
