/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

///////////////////////////////////////////////////////////////////////////////
// @doc     VDK_MODULE
// @module  Simple Time Service VDK | This module provides the Time for the
//      Node on which it is situated in seconds since Jan 1900 (RogueWave class)
//
//          Typically VDKs will be loaded by the Cyrano Daemon applciation
//          and utilise the Factory within that application.
//
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// Cyrano includes
#include <Daemon/CyrVdk.h>
#include "TimeService_i.h"
///////////////////////////////////////////////////////////////////////////////
// Global variables
TimeServiceImpl* TimeS=NULL;
///////////////////////////////////////////////////////////////////////////////
// @func   This function initialises Name service cleaner
// @rdesc A standard Cyrano error code.
VDK_EXP CyrVdkInitialise( const char* factory, CORBAServer* pServer )
{
    TimeS=new TimeServiceImpl(pServer);
    return CYR_SUCCESS;
}

///////////////////////////////////////////////////////////////////////////////
// @func  This function stops the  Name service cleaner
// @rdesc A standard Cyrano error code.
VDK_EXP CyrVdkUninitialise()
{
    delete TimeS;
    return CYR_SUCCESS;
}
