/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

///////////////////////////////////////////////////////////////////////////////
// @doc CyrFFApi
///////////////////////////////////////////////////////////////////////////////

#ifndef _CECFFServer_h
#define _CECFFServer_h

///////////////////////////////////////////////////////////////////////////////
// Cyrano includes
#include <definition.h>
#include <CyrException.h>

///////////////////////////////////////////////////////////////////////////////
// COM Imports
#include <windows.h>
#include <fstream>
using std::fstream;
class CYR_EXPORT CECFFBean
{
public:
    virtual ~CECFFBean();
protected:
    CECFFBean();
};

///////////////////////////////////////////////////////////////////////////////
// @class   CECFFServer | This class represents a wrapper around the COM
//          interface to the OpenSTARep database.  It is intended purely to hide
//          the COM mechanisms from products such as Impact.
// @base    public | CECFFBean
class CYR_EXPORT CECFFServer : public CECFFBean
{
    // @access Public Members
public:
    // @cmember Constructor
    CECFFServer( const char* user, const char* password );
    virtual ~CECFFServer();   // @cmember Destructor

    long      GetPort() const;          // @cmember Returns TCP/IP port of OpenSTARep database
    string GetProjects( long& count ) const;  // @cmember Returns list of Projects within Server
    string GetAddress() const;  // @cmember Returns list of Projects within Server
    string GetUserName() const;  // @cmember Returns list of Projects within Server
    string GetPassword() const;  // @cmember Returns list of Projects within Server


    // @access Protected Members
protected:
    string m_address;
    string m_username;
    string m_password;
    long      m_port;
};

#endif

