/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// OSEditCtrl.h: interface for the COSEditCtrl class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_OSEDITCTRL_H__898021C1_7815_11D4_AFE7_0001026CF512__INCLUDED_)
#define AFX_OSEDITCTRL_H__898021C1_7815_11D4_AFE7_0001026CF512__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <cmaxafx.h>
#include <CSerialization.h>
#include "EnumData.h"
#include "OSLanguage.h"

class CPreferencesPSheet ;
class COSEditCtrl : public CCodeMaxCtrl
{

public:
    COSLanguage         m_OSLanguage;

    CCSerialization     m_Serialization ;
public:
    COSEditCtrl( LPCSTR pczRegistryPath = NULL );
    virtual ~COSEditCtrl();

    void Init();
    void AddKeywords( char *_pszBuffer);

    virtual void InitKeywords();
    virtual void InitComments();
    virtual CString GetLanguageName();

    //Reading and saving the preferences for All the editors.
    virtual void ReadPreferences() ;
    virtual void SavePreferences() ;

    //Reading and saving of the standards preferences in the registry.
    void ReadGenericPreferences() ;
    void SaveGenericPreferences() ;

    //Apply preferences to the editor
    virtual void ApplyPreferences() ;

    //Add pages to the property pages of the Preference dialog
    virtual void AddPages( CPreferencesPSheet *pPSheet) ;

    virtual void SetWindowText( LPCTSTR lpszString ) ;
    virtual CString GetWindowText() ;

    CString GetString(long _lBeginLine, long _lEndLine);

    void DeleteLines(int nStartLine,int nEndLine);

    long GetCurrentLine();
    long GetCurrentCol() ;
    void InsertString( long lRow , CString strText ) ;
    void GoToLine( int nLine) ;
    void ClearSelection();

protected:
    void ReadGenericColor() ;
    void ReadGenericIndent() ;
    void ReadGenericFont() ;
    void SaveGenericColor() ;
    void SaveGenericIndent() ;
    void SaveGenericFont() ;
    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(COSEditCtrl)
    //}}AFX_VIRTUAL

    //{{AFX_MSG(COSEditCtrl)
    afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
    //}}AFX_MSG
    afx_msg void OnSelChange(NMHDR * pNotifyStruct, LRESULT* pResult);
    DECLARE_MESSAGE_MAP()

    CImageList m_ImageList;
};

#endif // !defined(AFX_OSEDITCTRL_H__898021C1_7815_11D4_AFE7_0001026CF512__INCLUDED_)
