/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// ExtendedDataTreeCtrl.h: interface for the CExtendedDataTreeCtrl class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EXTENDEDDATATREECTRL_H__DCBFDF86_8601_11D3_AC44_00105A483E3C__INCLUDED_)
#define AFX_EXTENDEDDATATREECTRL_H__DCBFDF86_8601_11D3_AC44_00105A483E3C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ExtendedTreeCtrl.h"

class CExtendedDataTreeCtrl : public CExtendedTreeCtrl
{
    DECLARE_DYNAMIC(CExtendedDataTreeCtrl)

    struct _TreeData
    {
        long        m_lElementID ;
        long        m_lParentElementID ;
        int         m_nImage ;
        int         m_nSelectedImage ;
        CString     m_strText ;

    } ;

    CList< _TreeData , _TreeData&> m_ModifyList ;

public:
    CExtendedDataTreeCtrl();
    virtual ~CExtendedDataTreeCtrl();

    BOOL DeleteItem( HTREEITEM hItem ) ;
    BOOL DeleteAllItems();

    BOOL ModifyItem( HTREEITEM hItem , long lParent ) ;

private :
    BOOL DeleteMapItem( HTREEITEM hParent ) ;

    BOOL ModifyMapItem( HTREEITEM hParent , long lOldParent) ;
    BOOL InsertOldItem() ;

};

#endif // !defined(AFX_EXTENDEDDATATREECTRL_H__DCBFDF86_8601_11D3_AC44_00105A483E3C__INCLUDED_)
