/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// ExtendedRichEditView.cpp: implementation of the CExtendedRichEditView class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ExtendedRichEditView.h"

//---------------------------------------------------------------------------

IMPLEMENT_DYNCREATE(CExtendedRichEditView, CView)

//---------------------------------------------------------------------------

BEGIN_MESSAGE_MAP(CExtendedRichEditView, CView)
//{{AFX_MSG_MAP(CExtendedRichEditView)
ON_WM_CREATE()
ON_WM_SIZE()
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//---------------------------------------------------------------------------

CExtendedRichEditView::CExtendedRichEditView()
{
    m_Edit.SetAsAControl(FALSE);
}

//---------------------------------------------------------------------------

CExtendedRichEditView::~CExtendedRichEditView()
{
}

//---------------------------------------------------------------------------


CExtendedRichEditCtrl*  CExtendedRichEditView::GetCtrl()
{
    return &m_Edit;
}

//---------------------------------------------------------------------------

void CExtendedRichEditView::OnDraw( CDC *pDC  )
{
    CDocument* pDoc = GetDocument();
}

//---------------------------------------------------------------------------

int CExtendedRichEditView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
    if (CView::OnCreate(lpCreateStruct) == -1)
        return -1;

    if ( ! m_Edit.Create( WS_CHILD|WS_VISIBLE|WS_VSCROLL|ES_MULTILINE|ES_WANTRETURN, CRect(0,0,0,0), this, 1 ) )
        return -1;
    return 0;
}

//---------------------------------------------------------------------------

void CExtendedRichEditView::OnSize(UINT nType, int cx, int cy)
{
    CView::OnSize(nType, cx, cy);

    m_Edit.MoveWindow( 0, 0, cx, cy , FALSE );
    m_Edit.UpdateWindow();

}
