#if !defined(AFX_EXTENDEDTREEVIEW_H__6A1078D4_010A_11D2_91B4_00104B4B2995__INCLUDED_)
#define AFX_EXTENDEDTREEVIEW_H__6A1078D4_010A_11D2_91B4_00104B4B2995__INCLUDED_
/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/


#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// ExtendedTreeView.h : header file
//

#include "AbstractTree.h"
#include <afxcview.h>
#include "StubDocument.h"

/////////////////////////////////////////////////////////////////////////////
// CExtendedTreeView view

class CExtendedTreeView : public CTreeView ,
            public CAbstractTree
{


    DECLARE_DYNCREATE(CExtendedTreeView)

    //pure virtual : init CAbstractTree
    virtual CTreeCtrl & GetTreeCtrl();


    // Operations
public:
    CExtendedTreeView(BOOL bDestroyInfoForDisplay = TRUE);           // protected constructor used by dynamic creation
    virtual ~CExtendedTreeView();

    CStubDocument * GetStubDocument() const ;

    //Get the tree root
    HTREEITEM GetAtLeastTheRoot( CPoint * pHitPoint ) const ;

    //insert items in the tree when you know the order
    HTREEITEM AddItem(  int         nDepth ,
                        int       * nLastDepth ,
                        HTREEITEM * hLastItem ,
                        LPCTSTR     lpszItem  = LPSTR_TEXTCALLBACK ,
                        void      * pItemData = NULL ,
                        int         nImage         = I_IMAGECALLBACK ,
                        int         nSelectedImage = I_IMAGECALLBACK ) ;

    //Insert Item according to the item id and the parent id
    BOOL InsertItem( HTREEITEM & hItem ,
                     LPCTSTR     lpszItem ,
                     int         nImage ,
                     int         nSelectedImage ,
                     DWORD       dwID ,
                     DWORD       dwParentID ) ;


    //init our own menu
    virtual void DoOwnerContextMenu( CMenu * pSubMenu ) ;

    // Contextual menus management :
    virtual BOOL DoPopupMenu( CPoint clientPoint ) ;

    // Implementation of the IDynMenu32Client interface :
    virtual HRESULT GetClientWindow( /*[out]*/ CWnd * * ppWnd ) ;
    // Get the window associated with the menu which will receive the messages
    virtual HRESULT GetCmdMsgTargetWindow( /*[out]*/ CWnd * * ppTargetWnd ) ;

    // Gives the client a chance of modifying the menu.
    virtual HRESULT OnPreMenuPopup( /*[in]*/ CMenu * pMenu ) ;

protected:

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CExtendedTreeView)
public :
    virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
    virtual void OnDraw(CDC* pDC);      // overridden to draw this view
    //}}AFX_VIRTUAL

    // Implementation
protected:

#ifdef _DEBUG
    virtual void AssertValid() const;
    virtual void Dump(CDumpContext& dc) const;
#endif

    // Generated message map functions
protected:
    //{{AFX_MSG(CExtendedTreeView)
    // NOTE - the ClassWizard will add and remove member functions here.
    afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
    // Menu Item Handlers :
    afx_msg void _OnExpandAll();
    afx_msg void _OnUpdateExpandAll(CCmdUI* pCmdUI);
    afx_msg void _OnCollapseAll();
    afx_msg void _OnUpdateCollapseAll(CCmdUI* pCmdUI);
    afx_msg void _OnExpand();
    afx_msg void _OnUpdateExpand(CCmdUI* pCmdUI);
    afx_msg void _OnCollapse();
    afx_msg void _OnUpdateCollapse(CCmdUI* pCmdUI);
    //
    afx_msg void OnInitMenuPopup( CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu );
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EXTENDEDTREEVIEW_H__6A1078D4_010A_11D2_91B4_00104B4B2995__INCLUDED_)
