/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// RegExpValid.h: interface for the CRegExpValid class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_REGEXPVALID_H__52A2C66B_2AB4_11D2_B096_0040950092BB__INCLUDED_)
#define AFX_REGEXPVALID_H__52A2C66B_2AB4_11D2_B096_0040950092BB__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000


#define NSUBEXP 10

class CRegExpValid
{

    BOOL        m_bCompil ;
public:
    CRegExpValid();
    virtual ~CRegExpValid();

    BOOL IsRegExpValid( CString &strRegExp ) ;
    BOOL IsVerify( CString & strValue ) ;

    BOOL VerifyRegExp( CString strRegExp ) ;

    CRegExpValid *RegComp( const TCHAR *re );
    int RegFind(const TCHAR *str);
    TCHAR* GetReplaceString( const TCHAR* sReplaceExp );
    int GetFindLen()
    {
        if( startp[0] == NULL || endp[0] == NULL )
            return 0;

        return endp[0] - startp[0];
    }


private:
    TCHAR *regnext(TCHAR *node);
    void reginsert(TCHAR op, TCHAR *opnd);

    int regtry(TCHAR *string);
    int regmatch(TCHAR *prog);
    size_t regrepeat(TCHAR *node);
    TCHAR *reg(int paren, int *flagp);
    TCHAR *regbranch(int *flagp);
    void regtail(TCHAR *p, TCHAR *val);
    void regoptail(TCHAR *p, TCHAR *val);
    TCHAR *regpiece(int *flagp);
    TCHAR *regatom(int *flagp);

    // Inline functions
private:
    TCHAR OP(TCHAR *p)
    {
        return *p;
    };
    TCHAR *OPERAND( TCHAR *p)
    {
        return (TCHAR*)((short *)(p+1)+1);
    };

    // regc - emit (if appropriate) a byte of code
    void regc(TCHAR b)
    {
        if (bEmitCode)
            *regcode++ = b;
        else
            regsize++;
    };

    // regnode - emit a node
    TCHAR *  regnode(TCHAR op)
    {
        if (!bEmitCode)
        {
            regsize += 3;
            return regcode;
        }

        *regcode++ = op;
        *regcode++ = _T('\0');     /* Null next pointer. */
        *regcode++ = _T('\0');

        return regcode-3;
    };


private:
    BOOL bEmitCode;
    BOOL bCompiled;
    TCHAR *sFoundText;

    TCHAR *startp[NSUBEXP];
    TCHAR *endp[NSUBEXP];
    TCHAR regstart;      // Internal use only.
    TCHAR reganch;    // Internal use only.
    TCHAR *regmust;      // Internal use only.
    int regmlen;      // Internal use only.
    TCHAR *program;      // Unwarranted chumminess with compiler.

    TCHAR *regparse;  // Input-scan pointer.
    int regnpar;      // () count.
    TCHAR *regcode;      // Code-emit pointer; dummy = don't.
    TCHAR regdummy[3];   // NOTHING, 0 next ptr
    long regsize;     // Code size.

    TCHAR *reginput;  // String-input pointer.
    TCHAR *regbol;    // Beginning of input, for ^ check.
}
;


#endif // !defined(AFX_REGEXPVALID_H__52A2C66B_2AB4_11D2_B096_0040950092BB__INCLUDED_)
