/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// RowSplitter.cpp: implementation of the CRowSplitter class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "RowSplitter.h"

//--------------------------------------------------------------------

BEGIN_MESSAGE_MAP(CRowSplitter, CSplitterWnd)
//{{AFX_MSG_MAP(CRowSplitter)
ON_WM_SIZE()
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//--------------------------------------------------------------------

CRowSplitter::CRowSplitter()
{
    m_cyFirstRow    = 0;
    m_cySecondRow   = 0;
}

//--------------------------------------------------------------------

CRowSplitter::~CRowSplitter()
{}

//--------------------------------------------------------------------


void CRowSplitter::OnSize(UINT nType, int cx, int cy)
{
    if ( m_pRowInfo == NULL )
    {
        CSplitterWnd::OnSize(nType, cx, cy);
        return;
    }

    if ( cy < m_cySecondRow)
    {
        SetRowInfo(0,0,0);
        SetRowInfo(1,cy,0);
    }
    else
    {
        SetRowInfo(0,cy - m_cySecondRow,0);
        SetRowInfo(1,m_cySecondRow,0);
    }

    CSplitterWnd::OnSize(nType, cx, cy);

}

//--------------------------------------------------------------------

void CRowSplitter::SetRowsSize(int _cyFirstRow, int _cySecondRow)
{
    m_cyFirstRow    = _cyFirstRow;
    m_cySecondRow   = _cySecondRow;
}

//--------------------------------------------------------------------

void CRowSplitter::TrackRowSize(int y, int row)
{
    CRect rc;
    GetClientRect(rc);

    m_cyFirstRow    = y;
    m_cySecondRow   = ( (rc.Height()-y) > 0 ? (rc.Height()-y): 0 );

    CSplitterWnd::TrackRowSize(y, row);

}
