/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// padview.h : header file
//

#ifndef _PADVIEW_H_
#define _PADVIEW_H_

/////////////////////////////////////////////////////////////////////////////
// CPadView view

class CPadView : public CEditView
{
    DECLARE_DYNCREATE(CPadView)
protected:
    CPadView();       // protected constructor used by dynamic creation

    enum UndoStatus { None = 0 , UnDone , ReDone } m_Undo ;

    // Attributes
public:

    // Operations
public:

    BOOL IsWordWrap() const ;
    BOOL IsReadOnly() const ;

    BOOL SetWordWrap( BOOL bWordWrap ) ;
    BOOL SetWordWrap( BOOL bWordWrap , BOOL bReadOnly ) ;

    void ResetStatus() ; // Appeler lors du changement de contenu (Gestion du undo)

    int GetTextSel( CString & strTextSel ) ;

    // Implementation
protected:
    virtual ~CPadView();
    virtual  void OnDraw(CDC* pDC);     // overridden to draw this view

    // Generated message map functions
protected:
    //{{AFX_MSG(CPadView)
    // NOTE - the ClassWizard will add and remove member functions here.
    afx_msg void OnUpdateEditUndo(CCmdUI* pCmdUI);
    afx_msg void OnEditUndo();
    afx_msg void OnUpdateEditRedo(CCmdUI* pCmdUI);
    afx_msg void OnEditRedo();
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
// CMarkupPadView view

// --------------------------------------------------------------------------

class CMarkupPadView : public CPadView
{
    DECLARE_DYNCREATE(CMarkupPadView)
protected:
    CMarkupPadView();       // protected constructor used by dynamic creation

    // Attributes
public:

    // Operations
public:

    BOOL HasDelimitedToken( const char * pczBegDelim , const char * pczEndDelim ) ;
    BOOL SelectBetween( const char * pczFom , const char * pczTo ) ;

    // Implementation
protected:
    virtual ~CMarkupPadView();
    virtual  void OnDraw(CDC* pDC);     // overridden to draw this view

    // Generated message map functions
protected:
    //{{AFX_MSG(CMarkupPadView)
    // NOTE - the ClassWizard will add and remove member functions here.
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

#endif // _PADVIEW_H_

