/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__E2B26DD7_886E_11D1_9BF5_00A0243D1382__INCLUDED_)
#define AFX_MAINFRM_H__E2B26DD7_886E_11D1_9BF5_00A0243D1382__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "TrayIcon.h"
#include "CYRWDT001.h"

class CMainFrame : public CFrameWnd
{
public:
    CMainFrame();
    DECLARE_DYNCREATE(CMainFrame)

    // Attributes
public:
    CTrayIcon m_TrayIcon;

    // Operations
public:

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CMainFrame)
    //}}AFX_VIRTUAL

    // Implementation
public:
    virtual ~CMainFrame();

    // Readers + Writers
    CString GetCyranoHome()
    {
        return m_CyranoHome;
    }
    int     StartProcess(CString& Command ,HANDLE* pReturnHandle ,DWORD* pReturnPid);
    BOOL    FileExists          (CString &FileName);

#ifdef _DEBUG
    virtual void AssertValid() const;
    virtual void Dump(CDumpContext& dc) const;
#endif

    // Generated message map functions
protected:
    //{{AFX_MSG(CMainFrame)
    afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
    afx_msg void OnPopupStart();
    afx_msg void OnPopupStop();
    afx_msg void OnUpdateStart(CCmdUI* pCmdUI);
    afx_msg void OnUpdateStop(CCmdUI* pCmdUI);
    afx_msg void OnAppExit();
    afx_msg void OnPopupConfigure();
    afx_msg void OnRegisteredObjects();
    afx_msg void OnTimer(UINT nIDEvent);
    //}}AFX_MSG
    afx_msg LONG OnTrayNotification(UINT wParam, LONG lParam);
    DECLARE_MESSAGE_MAP()

private:
    HANDLE  m_hDataServer;
    DWORD   m_DataServerPid;
    bool    m_Stopping;
    bool    m_AutoStart;
    CString m_CyranoHome;
    BOOL    m_bRunNamesService;
    BOOL    m_bTrace;
    BOOL    m_bNotify;
    BOOL    m_bRegObjectsVisible;
    BOOL    m_bConfigureVisible;
    BOOL    m_bProcessCheck;

private:
    BOOL    DirExists           (CString &DirPath ,BOOL CreateIfNot = FALSE);
    bool    CheckConfiguration  ();
    void    StopDaemon          ();
    void    StartNamesService   ();
    int     StartDaemon         ();
    void    DeleteUsedLogs      ();
    void    AutoStart           ();
    bool    CheckDiskSpace      ();
    void    StopNamesService    ();

	CYRWDT001 m_OmniOrb;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__E2B26DD7_886E_11D1_9BF5_00A0243D1382__INCLUDED_)
