/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// LicenceDlg.cpp : implementation file
//

#include "stdafx.h"
#include "modeller.h"
#include "LicenceDlg.h"
#include "htmlhelp.h"
#include "Help\LicenceDlg.inl"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLicenceDlg dialog


CLicenceDlg::CLicenceDlg(CWnd* pParent /*=NULL*/)
        : CDialog(CLicenceDlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(CLicenceDlg)
    m_strLicence = _T("");
    //}}AFX_DATA_INIT
}



void CLicenceDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CLicenceDlg)
    DDX_Text(pDX, IDC_LICENCE, m_strLicence);
    //}}AFX_DATA_MAP
}



BEGIN_MESSAGE_MAP(CLicenceDlg, CDialog)
//{{AFX_MSG_MAP(CLicenceDlg)
ON_WM_HELPINFO()
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLicenceDlg message handlers

BOOL CLicenceDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    HRSRC hRes = FindResource(AfxGetApp()->m_hInstance,MAKEINTRESOURCE(IDR_LICENCE_TXT),"TEXTFILE");
    HGLOBAL hGlobal = LoadResource(AfxGetApp()->m_hInstance,hRes);
    const char *pszLicence = (const char*)LockResource(hGlobal);
    if(pszLicence)
        m_strLicence = pszLicence;
    UpdateData(FALSE);

    return TRUE;  // return TRUE unless you set the focus to a control
    // EXCEPTION: OCX Property Pages should return FALSE
}


BOOL CLicenceDlg::OnHelpInfo(HELPINFO* pHelpInfo)
{
    CString contextHelp;
    contextHelp.LoadString(IDS_MODELLER_HELP_FILE);
    contextHelp= getenv("CYRANO_HOME")+contextHelp+"::whatisthis.txt";

    if (pHelpInfo->iCtrlId == IDC_STATIC)
        return true;

    CWnd* pWnd = GetDlgItem(pHelpInfo->iCtrlId);

	if(pWnd)
	    HtmlHelp(pWnd->m_hWnd, contextHelp, HH_TP_HELP_CONTEXTMENU, (DWORD)(LPVOID)g_TopicIdArray);

    return true;
}
