/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// VariableInfo.h: interface for the CVariableInfo class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VARIABLEINFO_H__52C27844_8AF6_4C49_A6A8_40DE4D6E15FC__INCLUDED_)
#define AFX_VARIABLEINFO_H__52C27844_8AF6_4C49_A6A8_40DE4D6E15FC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ScriptItemInfo.h"

class CVariableInfo : public CScriptItemInfo  
{
public:
	typedef enum {enCharacter,enInteger} VariableType;
	typedef enum {enLocal,enThread,enScript,enGlobal} VariableScope;

	CVariableInfo(VariableType nType,char* szName,int nSize,LPCTSTR szInit,VariableScope nScope,
		LPCTSTR szFileName,bool bRandom,int nStartLine,int nEndLine);

	virtual ~CVariableInfo();

	void GetName(CString& strName)const{strName = m_strName;}
	bool IsRandom()const{return m_bRandom;}
	int GetSize()const {return m_nSize;}
	BOOL GetFilename(CString& strFilename) const;
	VariableType GetType()const{return m_nType;}
	VariableScope GetScope()const{return m_nScope;}
	void GetInitialisationValues(CStringArray& arstrValues);
	
#ifdef _DEBUG
	void Dump() const;
#endif

private:
	VariableType m_nType;		//character or integer...
	CString m_strName;
	int m_nSize;
	CString m_strInitialisation;	
	VariableScope m_nScope;
	CString m_strFileName;
	bool m_bRandom;
};

#endif // !defined(AFX_VARIABLEINFO_H__52C27844_8AF6_4C49_A6A8_40DE4D6E15FC__INCLUDED_)
