/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// CECProjectOpenDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CECCommander.h"
#include "CECProjectOpenDlg.h"
#include "htmlhelp.h"
#include "Server.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "..\..\HTMLHelp\Commander\Open_Project.inl"

/////////////////////////////////////////////////////////////////////////////
// CECProjectOpenDlg dialog


CECProjectOpenDlg::CECProjectOpenDlg(CWnd* pParent /*=NULL*/)
        : CDialog(CECProjectOpenDlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(CECProjectOpenDlg)
    // NOTE: the ClassWizard will add member initialization here
    //}}AFX_DATA_INIT

    m_szHtmlHelpFile = getenv("CYRANO_HOME");
    m_szHtmlHelpFile += "\\Framework\\Help\\Commander.chm";
}


void CECProjectOpenDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CECProjectOpenDlg)
    DDX_Control(pDX, IDC_PROJLIST, m_projList);
    //}}AFX_DATA_MAP
}



BEGIN_MESSAGE_MAP(CECProjectOpenDlg, CDialog)
//{{AFX_MSG_MAP(CECProjectOpenDlg)
ON_WM_HELPINFO()
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CECProjectOpenDlg message handlers

BOOL CECProjectOpenDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    LoadProjects();
    return TRUE;  // return TRUE unless you set the focus to a control
    // EXCEPTION: OCX Property Pages should return FALSE
}


void CECProjectOpenDlg::LoadProjects()
{
    //Recover the server
    CECCommanderApp* pApp = (CECCommanderApp*) AfxGetApp();
    ASSERT (pApp != NULL);
    CYRServer *pServer = pApp->GetServer();

    //Get a list of projects from the server
    CStringArray arstrProjectList;
    pServer->GetProjectList(arstrProjectList);

    CString strOpenProjectName = pServer->GetOpenProjectName();

    if(!arstrProjectList.GetSize())
    {
        AfxMessageBox("There are no available projects.");
        EndDialog(IDCANCEL);
        return;
    }

    for(int nNdx=0;nNdx<arstrProjectList.GetSize();nNdx++)
    {
        if(arstrProjectList[nNdx]!=strOpenProjectName)
            m_projList.AddString(arstrProjectList[nNdx]);
    }

    m_projList.SetCurSel(0);
}

void CECProjectOpenDlg::OnOK()
{
    int nSelected = m_projList.GetCurSel();

    if(nSelected != CB_ERR)
        m_projList.GetLBText(nSelected,m_strProjectName);

    CDialog::OnOK();
}

BOOL CECProjectOpenDlg::OnHelpInfo(HELPINFO* pHelpInfo)
{
    CString contextHelp = m_szHtmlHelpFile+"::whatisthis.txt";

    if (pHelpInfo->iCtrlId == IDC_STATIC)
        return true;

    CWnd* pWnd = GetDlgItem(pHelpInfo->iCtrlId);

	if(pWnd)
	    HtmlHelp(pWnd->m_hWnd, contextHelp, HH_TP_HELP_CONTEXTMENU, (DWORD)(LPVOID)g_TopicIdArray);

    return true;
}
