/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// FullScreenDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CECCommander.h"
#include "FullScreenDlg.h"
#include "CECWorkspace.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFullScreenDlg dialog


CFullScreenDlg::CFullScreenDlg(CWnd* pParent /*=NULL*/)
        : CDialog(CFullScreenDlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(CFullScreenDlg)
    // NOTE: the ClassWizard will add member initialization here
    //}}AFX_DATA_INIT
}



void CFullScreenDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CFullScreenDlg)
    // NOTE: the ClassWizard will add DDX and DDV calls here
    //}}AFX_DATA_MAP
}



BEGIN_MESSAGE_MAP(CFullScreenDlg, CDialog)
//{{AFX_MSG_MAP(CFullScreenDlg)
ON_WM_CLOSE()
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFullScreenDlg message handlers

void CFullScreenDlg::OnOK()
{
    CECWorkspace* pWorkspace = CECCommanderApp::GetWorkspace();
    ASSERT(pWorkspace != NULL);

    CRect rc;
    GetWindowRect(&rc);

    pWorkspace->SetFullScreenDlgPos(rc);

    GetParent()->PostMessage(WM_COMMAND,MAKEWPARAM(ID_VIEW_FULLSCREEN,0),0);
    CDialog::OnOK();
}

BOOL CFullScreenDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    CECWorkspace* pWorkspace = CECCommanderApp::GetWorkspace();
    ASSERT(pWorkspace != NULL);

    CString strPos = pWorkspace->GetFullScreenDlgPos();
    CRect rc(pWorkspace->StringToRect(strPos));

    SetWindowPos(NULL,rc.left,rc.top,0,0,SWP_NOZORDER|SWP_NOSIZE);

    return TRUE;  // return TRUE unless you set the focus to a control
    // EXCEPTION: OCX Property Pages should return FALSE
}


void CFullScreenDlg::OnClose()
{}


void CFullScreenDlg::OnCancel()
{}
