/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

/////////////////////////////////////////////////////////////////////////
//
// CECClipboard.cpp
// ----------------
//
//    This is the Implementation file for the CECClipboard class.
//
//=========================================================================

#include "stdafx.h"
#include "CECClipboard.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CECClipboard

CECClipboard::CECClipboard()
{}


CECClipboard::~CECClipboard()
{}


//
// SetClipboardText
// ================
//
// Put some text on the clipboard so that another module can retrieve it
//

void CECClipboard::SetClipboardText(CString szText)
{
    // Declare a new data source
    COleDataSource *pds = new COleDataSource;

    // And put the Test Objects Name on the Clipboard
    PTCHAR cp = (PTCHAR)GlobalAlloc(GMEM_FIXED, (szText.GetLength() *
                                    sizeof(TCHAR)) + sizeof(TCHAR));
    _tcscpy(cp, szText);
    pds->CacheGlobalData(CF_TEXT, cp);
    pds->SetClipboard();
}

//
// GetClipboardText
// ================
//
// Retrieve some clipboard text
//
CString CECClipboard::GetClipboardText()
{
    CString strText;

    // Attach to the Clipboard via a COleDataObject
    COleDataObject data;
    if (data.AttachClipboard())
    {
        // Make sure we are getting text ...
        if(data.IsDataAvailable(CF_TEXT))
        {
            // And get hold of it
            HGLOBAL hg;
            if(hg = data.GetGlobalData(CF_TEXT))
            {
                CString strClipboardText = (LPCTSTR)GlobalLock(hg);
                GlobalUnlock(hg);

                // Set up the Node with the new text ...
                strText = strClipboardText;
            }
        }
        data.Release();
    }
    return strText;
}
