/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// CECOTAThresholds.h: interface for the CECOTAThresholds class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CECOTATHRESHOLDS_H__32EEB2E5_0EB8_11D4_BD8D_00C04F89E392__INCLUDED_)
#define AFX_CECOTATHRESHOLDS_H__32EEB2E5_0EB8_11D4_BD8D_00C04F89E392__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CECOTAThresholds
{
public:
    CECOTAThresholds(const CString& strPhysicalNode);
    virtual ~CECOTAThresholds();

    void SetCPUThreshold(int nThreshold)
    {
        m_nCPUThreshold = nThreshold;
    }
    void SetNetThreshold(int nThreshold)
    {
        m_nNetThreshold = nThreshold;
    }
    void SetSwapThreshold(int nThreshold)
    {
        m_nSwapThreshold = nThreshold;
    }

    int GetCPUThreshold()
    {
        return m_nCPUThreshold;
    }
    int GetNetThreshold()
    {
        return m_nNetThreshold;
    }
    int GetSwapThreshold()
    {
        return m_nSwapThreshold;
    }
private:
    void LoadThresholds();
    void SaveThresholds();

    int m_nCPUThreshold;
    int m_nNetThreshold;
    int m_nSwapThreshold;

    CString m_strPhysicalNode;
    CString m_strThresholdFile;
};

#endif // !defined(AFX_CECOTATHRESHOLDS_H__32EEB2E5_0EB8_11D4_BD8D_00C04F89E392__INCLUDED_)
