/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

/////////////////////////////////////////////////////////////////////////
//
// CECTssWriter.h
// --------------
//
//    This is the include file for the CECTssWriter class
//
//=========================================================================

#ifndef CECTssWriter_Loaded
#define CECTssWriter_Loaded

#include "CECDefaultCodeWriter.h"

class CECTssWriter : public CECDefaultCodeWriter
{
    // Construction
public:
    CECTssWriter    ();
    ~CECTssWriter();

    enum TSS_SECTION {  HEADER = TSS_HEADER,
                        ENVIRONMENT = TSS_ENVIRONMENT,
                        DEFINITIONS = TSS_DEFINITIONS,
                        CODE = TSS_CODE,
                        EXIT = TSS_EXIT};

    CString GetTemplateText(TSS_SECTION nType, CString szFileName = "");
    CString GetSectionTitle(TSS_SECTION nType);

    CString GetDescriptionStatement(TSS_SECTION nType, CString szDescription="");
    CString GetTestStatement(TSS_SECTION nType, CString szTestName="", CString szNode="");
    CString GetThreadStatement(TSS_SECTION nType, CString szTestName="",int nUserThreads=1, int nInterval=0,CString szTargetName="");
    CString GetOTAThreadStatement(TSS_SECTION nType,CString szThreadName,CString szTestName =_T(""),CString szTargetNode =_T(""));
    CString GetSynchronizationStatement(TSS_SECTION nType, CStringArray* arSynchArray = NULL);
    CString GetDelayStatement(TSS_SECTION nType, int nDelay =10);

    CString GetNameDefinitionText(TSS_SECTION nType, CString szTestName = "", CString szDescription = "");
    CString GetCurrentTargetEnvironment();
};
#endif
