/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// InjectorViewRefreshRateDlg.cpp : implementation file
//

#include "stdafx.h"
#include "InjectorViewRefreshRateDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "..\..\..\HTMLHelp\CYRGenericCtrls\Injector_Refresh.inl"
#include "htmlhelp.h"

/////////////////////////////////////////////////////////////////////////////
// CInjectorViewRefreshRateDlg dialog


CInjectorViewRefreshRateDlg::CInjectorViewRefreshRateDlg(int nRefreshRate,CWnd* pParent /*=NULL*/)
        : CDialog(CInjectorViewRefreshRateDlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(CInjectorViewRefreshRateDlg)
    m_strRateText = _T("");
    //}}AFX_DATA_INIT
    m_nRefreshRate = nRefreshRate;
    m_szHtmlHelpFile = getenv("CYRANO_HOME");
    m_szHtmlHelpFile += "\\Framework\\Help\\Commander.chm";
}


void CInjectorViewRefreshRateDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CInjectorViewRefreshRateDlg)
    DDX_Control(pDX, IDC_RATE_SLIDER, m_ctlRateSlider);
    DDX_Text(pDX, IDC_RATE_TEXT, m_strRateText);
    //}}AFX_DATA_MAP
}



BEGIN_MESSAGE_MAP(CInjectorViewRefreshRateDlg, CDialog)
//{{AFX_MSG_MAP(CInjectorViewRefreshRateDlg)
ON_WM_HSCROLL()
ON_WM_HELPINFO()
ON_BN_CLICKED(IDC_FULL_HELP, OnFullHelp)
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CInjectorViewRefreshRateDlg message handlers
BOOL CInjectorViewRefreshRateDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    HBITMAP     hBitMap;
    HINSTANCE   hInstance = AfxGetInstanceHandle ();
    hBitMap = LoadBitmap (hInstance ,MAKEINTRESOURCE (IDB_HELP));
    ASSERT (hBitMap != NULL);
    CButton* pBP = (CButton*)GetDlgItem(IDC_FULL_HELP);
    pBP->SetBitmap(hBitMap);


    m_ctlRateSlider.SetRange(1,60);
    m_ctlRateSlider.SetTicFreq(10);

    m_ctlRateSlider.SetPos(m_nRefreshRate);
    m_strRateText.Format("%d Seconds",m_nRefreshRate);

    UpdateData(FALSE);

    return TRUE;  // return TRUE unless you set the focus to a control
    // EXCEPTION: OCX Property Pages should return FALSE
}


void CInjectorViewRefreshRateDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
    if(pScrollBar)
    {
        UpdateData(TRUE);
        switch(pScrollBar->GetDlgCtrlID())
        {
        case IDC_RATE_SLIDER:
            m_strRateText.Format("%d Seconds",m_ctlRateSlider.GetPos());
            break;
        }
        UpdateData(FALSE);
    }

    CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}


void CInjectorViewRefreshRateDlg::OnOK()
{
    UpdateData();
    m_nRefreshRate = atoi(m_strRateText);

    CDialog::OnOK();
}

BOOL CInjectorViewRefreshRateDlg::OnHelpInfo(HELPINFO* pHelpInfo)
{
    CString contextHelp = m_szHtmlHelpFile+"::whatisthis.txt";

    if (pHelpInfo->iCtrlId == IDC_STATIC)
        return true;

    CWnd* pWnd = GetDlgItem(pHelpInfo->iCtrlId);

	if(pWnd)
	    HtmlHelp(pWnd->m_hWnd, contextHelp, HH_TP_HELP_CONTEXTMENU, (DWORD)(LPVOID)g_TopicIdArray);

    return true;
}

void CInjectorViewRefreshRateDlg::OnFullHelp()
{
    HtmlHelp(m_hWnd, m_szHtmlHelpFile, HH_DISPLAY_TOPIC, (DWORD)"xcyrgene.htm");
}
