/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

////////////////////////////////////////////////////////////////////////////////
// @doc     Document
// @module  AnalyzerDefs.h | Analyzer Definitiions
//
////////////////////////////////////////////////////////////////////////////////


#ifndef __ANALYZER_DEFS__
#define __ANALYZER_DEFS__

// Default Line Colours
#define MAX_DEF_COLOURS     10

#define CLR_BLUE        RGB(0, 0, 192)
#define CLR_RED         RGB(192, 0, 0)
#define CLR_GREEN       RGB(0, 192, 0)
#define CLR_CYAN        RGB(0, 255, 255)
#define CLR_YELLOW      RGB(255, 255, 0)
#define CLR_MAGENTA     RGB(255, 0, 255)
#define CLR_GREY        RGB(192, 192, 192)
#define CLR_MAUVE       RGB(128, 0, 255)
#define CLR_PURPLE      RGB(64, 0, 128)
#define CLR_ORANGE      RGB(255, 128, 0)
#define CLR_PINK        RGB(255, 128, 192)
#define CLR_BROWN       RGB(128, 64, 0)
#define CLR_OLIVE       RGB(128, 128, 0)

// Window Types
typedef enum{
    enCumFreqGraph,
    enStdFreqGraph,
    enPercentFreqGraph,
    enSimpleOTAGraph,
    enRTATGraph,
    enRTTimeGraph,
    enUsersTimeGraph,
    enPercentCPUGraph,
    enPageSwapGraph,
    enPercentNetUseGraph,
    enSummaryScreen,
    enSortedList,
    enHttpList,
	enVUsersTimeGraph,

    enKbPerSecondGraph,
    enAVPRTPerUserGraph,
    enErrorsPerUserGraph,
    enErrorsTimeGraph,
    enHitsPerSecondGraph,
    enPagesPerSecondGraph,

    enNumGraphTypes,

    enInvalidGraphType = 0xffffffff
} GraphTypesEnum;

const CString strPercentCPUHeading(_T("% CPU Usage"));
const CString strPageSwappingHeading(_T("PAGE SWAPPING"));
const CString strPercentNetUseHeading(_T("% NET USE"));

//These values are obtained from the VtChSeriesType
//enum in the MSChart20.ocx typelib
const int VtChSeriesType2dBar = 1;
const int VtChSeriesType2dLine = 6;
const int VtChSeriesType2dArea = 8;

#endif //__ANALYZER_DEFS__
