/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// CECGlobalSettings.h: interface for the CECGlobalSettings class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CECGLOBALSETTINGS_H__3F02A765_EA98_11D3_BD7F_00C04F89E392__INCLUDED_)
#define AFX_CECGLOBALSETTINGS_H__3F02A765_EA98_11D3_BD7F_00C04F89E392__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "AnalyzerDefs.h"
class CECWorkspace;

class CECGlobalSettings
{
public:
    CECGlobalSettings();
    virtual ~CECGlobalSettings();

public:
    void RemoveAllRunInfo();

    // @cmember Over-ridden to add doc templates to CECDocManager
    void AddDocTemplate(CDocTemplate* pTemplate);

    // @cmember Get information about a loded data set
    BOOL GetRunInfo(int index, CString& strTestRun);

    // @cmember Add information about a loded data set
    void AddRunInfo(const CString& strTestRun);

    // @cmember Get the cout of loaded data sets
    int GetLoadedCount();

    // @cmember Retrieve workspace information for saving/restoring window positions
    CECWorkspace* GetWorkSpace()
    {
        return m_pWorkspace;
    }
public:
    // @cmember Graph title text colour
    COLORREF m_TitleTextCol;

    // @cmember Graph title background start colour
    COLORREF m_TitleBGCol;

    // @cmember Graph title font type
    CString  m_TitleFont;

    BOOL m_bShowTitle;

    // @cmember Graph title font size
    int      m_TitleFontSize;

    // @cmember Graph label colour
    COLORREF m_LabelCol;

    // @cmember Graph background colour
    COLORREF m_BGCol;

    // @cmember Axis Title colour
    COLORREF m_ATCol;

    // @cmember Graph grid line colour
    COLORREF m_GridCol;

    // @cmember Graph Label Font type
    CString  m_LabelFont;

    // @cmember Array of default data line colours for the graphs
    DWORD    m_nDefLineColours[MAX_DEF_COLOURS];

    // @cmember Used in creation of a new graph window
    int m_GraphCreateType;

    // @access Private Members
private:
    // @cmember Stores information about the data sets loaded into the hidden grid.
    CStringArray m_RunsLoaded;

    void LoadGraphSettings();
    void SaveGraphSettings();

    // @cmember Workspace information
    CECWorkspace*      m_pWorkspace;
};

#endif // !defined(AFX_CECGLOBALSETTINGS_H__3F02A765_EA98_11D3_BD7F_00C04F89E392__INCLUDED_)
