#if !defined(AFX_GRAPHVIEW_H__9F0F39C4_F407_11D3_BD83_00C04F89E392__INCLUDED_)
#define AFX_GRAPHVIEW_H__9F0F39C4_F407_11D3_BD83_00C04F89E392__INCLUDED_
/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// GraphView.h : header file
//
#include "resource.h"
#include "XChartCtrl.h"

/////////////////////////////////////////////////////////////////////////////
// CGraphView view
class CGraphTypeBase;
class CGraphView : public CFormView
{
protected:
    CGraphView();           // protected constructor used by dynamic creation
    DECLARE_DYNCREATE(CGraphView)

    // Attributes
public:

    void SetGraph(CGraphTypeBase *pGraph)
    {
        m_pGraph = pGraph;
    }
    void SetDocument(CDocument *pDoc)
    {
        m_pDocument = pDoc;
    }
    // Operations
public:
    CGraphTypeBase *m_pGraph;

    // Dialog Data
    //{{AFX_DATA(CFormView)
    enum { IDD = IDD_CHART_DLG };
    CXChartCtrl m_ctlChart;
    //}}AFX_DATA

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CGraphView)
public:
    virtual void OnInitialUpdate();
protected:
    virtual void OnDraw(CDC* pDC);      // overridden to draw this view
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

    // Implementation
protected:
    virtual ~CGraphView();
#ifdef _DEBUG
    virtual void AssertValid() const;
    virtual void Dump(CDumpContext& dc) const;
#endif

    // Generated message map functions
protected:
    //{{AFX_MSG(CGraphView)
    afx_msg void OnGraphCustomize();
    afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
    afx_msg void OnExport();
    afx_msg void OnDestroy();
    afx_msg void OnSize(UINT nType, int cx, int cy);
    afx_msg BOOL OnEraseBkgnd(CDC *pDC);
    //}}AFX_MSG
    afx_msg void OnPrint();
    afx_msg void OnGraphMenuItemCommand(UINT uiCommand);
    afx_msg LRESULT OnGraphDataChanged(WPARAM,LPARAM);
    afx_msg void OnUpdateFilePrint(CCmdUI *pCmdUI);
    DECLARE_MESSAGE_MAP()

    CDocument *m_pDocument;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GRAPHVIEW_H__9F0F39C4_F407_11D3_BD83_00C04F89E392__INCLUDED_)
