/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

/////////////////////////////////////////////////////////////////////////
//
// CYRNewNode.cpp
// --------------
//
//    This is the implementation file for the CYRNewNode class
//
//=========================================================================
#include "stdafx.h"
#include "resource.h"
#include "CYRNewNode.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CYRNewNode dialog


CYRNewNode::CYRNewNode(CWnd* pParent /*=NULL*/)
        : CDialog(CYRNewNode::IDD, pParent)
{
    //{{AFX_DATA_INIT(CYRNewNode)
    m_szName = _T("");
    //}}AFX_DATA_INIT
}



void CYRNewNode::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CYRNewNode)
    DDX_Text(pDX, IDC_NEW_NODE_NAME, m_szName);
    DDV_MaxChars(pDX, m_szName, 16);
    //}}AFX_DATA_MAP
}



BEGIN_MESSAGE_MAP(CYRNewNode, CDialog)
//{{AFX_MSG_MAP(CYRNewNode)
ON_EN_CHANGE(IDC_NEW_NODE_NAME, OnChangeNewNodeName)
//}}AFX_MSG_MAP
ON_UPDATE_COMMAND_UI(IDOK, OnUpdateOK)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CYRNewNode message handlers

void CYRNewNode::OnOK()
{
    UpdateData(TRUE);

    // Get the VTEST data name
    m_DataNameEdit.GetData(m_szName, TRUE);

    CDialog::OnOK();
}

//
// OnUpdateOK
// ==========
//
// Only enable the OK button if something has been entered
//
void CYRNewNode::OnUpdateOK(CCmdUI* pCmdUI)
{
    m_DataNameEdit.GetData(m_szName, TRUE);
    BOOL bState = (m_szName.IsEmpty()) ? FALSE : TRUE;

    pCmdUI->Enable(bState);
}

BOOL CYRNewNode::OnInitDialog()
{
    CDialog::OnInitDialog();

    // Add the V-Test Dataname - yuch
    m_DataNameEdit.SubclassEdit (IDC_NEW_NODE_NAME, this, 0);
    m_DataNameEdit.SetLength(16);
    m_DataNameEdit.SetData(m_szName);

    return TRUE;  // return TRUE unless you set the focus to a control
    // EXCEPTION: OCX Property Pages should return FALSE
}


void CYRNewNode::OnChangeNewNodeName()
{
    // Simply update the dialogs which depend on this
    UpdateDialogControls(GetParent(), FALSE);
}
