#if !defined(AFX_CYRGROUPTESTWIZARD_H__5EF718A7_03B7_11D4_BD87_00C04F89E392__INCLUDED_)
#define AFX_CYRGROUPTESTWIZARD_H__5EF718A7_03B7_11D4_BD87_00C04F89E392__INCLUDED_
/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CYRGroupTestWizard.h : header file
//

#include "..\..\Common\CECDataName.h"

/////////////////////////////////////////////////////////////////////////////
// CYRWizardBasePage dialog
class CYRServer;
class CYRWizardBasePage : public CPropertyPage
{
    DECLARE_DYNCREATE(CYRWizardBasePage)

    // Construction
public:
CYRWizardBasePage(int nPageId): CPropertyPage(nPageId)
    {}

    ~CYRWizardBasePage()
    {}


public:
    virtual BOOL OnWizardFinish();

    virtual void SavePageSettings(const CString& strWizardFile)
    {}

    virtual void LoadPageSettings(const CString& strWizardFile)
    {}
    // Implementation

protected:
    CYRWizardBasePage()
    {}

};

/////////////////////////////////////////////////////////////////////////////
// CYRNameDefinitionPage dialog

class CYRNameDefinitionPage : public CYRWizardBasePage
{
    // Construction
public:
    CYRNameDefinitionPage(CWnd* pParent = NULL);   // standard constructor

    // Dialog Data
    //{{AFX_DATA(CYRNameDefinitionPage)
    enum { IDD = IDD_WIZ_NAME_DEFINITION_PAGE };
    CString m_strTestDescription;
    CString m_strTestName;
    //}}AFX_DATA
    CECDataName m_ctlTestName;

    void SavePageSettings(const CString& strWizardFile);
    void LoadPageSettings(const CString& strWizardFile);


    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CYRNameDefinitionPage)
public:
    virtual BOOL OnSetActive();
    virtual BOOL OnKillActive();
    virtual void OnOK();
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

    // Implementation
protected:

    // Generated message map functions
    //{{AFX_MSG(CYRNameDefinitionPage)
    virtual BOOL OnInitDialog();
    afx_msg void OnSetfocusTestDescription(NMHDR* pNMHDR, LRESULT* pResult);
    afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
private:
    CString m_szHtmlHelpFile;
};
/////////////////////////////////////////////////////////////////////////////
// CYRSummaryPage dialog

class CYRSummaryPage : public CYRWizardBasePage
{
    DECLARE_DYNCREATE(CYRSummaryPage)

    // Construction
public:
    CYRSummaryPage();   // standard constructor

    // Dialog Data
    //{{AFX_DATA(CYRSummaryPage)
    enum { IDD = IDD_WIZ_SUMMARY_PAGE };
    CEdit   m_ctlSummary;
    CString m_strSummary;
    //}}AFX_DATA

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CYRSummaryPage)
public:
    virtual BOOL OnSetActive();
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

    // Implementation
protected:

    // Generated message map functions
    //{{AFX_MSG(CYRSummaryPage)
    afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()

    void ComposeSummary();
private:
    CString m_szHtmlHelpFile;
};
/////////////////////////////////////////////////////////////////////////////
// CYRGroupDependencyPage dialog

class CYRGroupDependencyPage : public CYRWizardBasePage
{
    // Construction
public:
    CYRGroupDependencyPage(CWnd* pParent = NULL);   // standard constructor

    // Dialog Data
    //{{AFX_DATA(CYRGroupDependencyPage)
    enum { IDD = IDD_WIZ_GROUP_DEPENDENCY_PAGE };
    CListCtrl   m_ctlAvailable;
    CListCtrl   m_ctlSelected;
    //}}AFX_DATA

    void SavePageSettings(const CString& strWizardFile);
    void LoadPageSettings(const CString& strWizardFile);

    int GetNumSelectedTests()
    {
        return m_arSelectedTests.GetSize();
    }
    const CString& GetSelectedTest(int nNdx)
    {
        return m_arSelectedTests[nNdx];
    }
    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CYRGroupDependencyPage)
public:
    virtual BOOL OnSetActive();
    virtual BOOL OnKillActive();
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL
    virtual LRESULT OnWizardBack();

    // Implementation
protected:

    // Generated message map functions
    //{{AFX_MSG(CYRGroupDependencyPage)
    virtual BOOL OnInitDialog();
    afx_msg void OnDeselect();
    afx_msg void OnDeselectAll();
    afx_msg void OnSelect();
    afx_msg void OnSelectAll();
    afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()

    CStringArray m_arSelectedTests;
    void FillTestLists();
private:
    BOOL m_bOnBack;
    CString m_szHtmlHelpFile;
};


/////////////////////////////////////////////////////////////////////////////
// CYRGroupTestWizardSheet

class CYRGroupTestWizardSheet : public CPropertySheet
{
    DECLARE_DYNAMIC(CYRGroupTestWizardSheet)

    typedef enum {enNameDefPage,enGroupDepPage,enSummaryPage,enMaxPageNdx} PageNdxs;

    // Construction
public:
    CYRGroupTestWizardSheet(UINT nIDCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0,const CString& strTestName = "");
    CYRGroupTestWizardSheet(LPCTSTR pszCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0,const CString& strTestName = "");

    bool IsValidFilename(const CString& strFilename,bool bTellUser = true);
    // Attributes
public:

    // Operations
public:

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CYRGroupTestWizardSheet)
public:
    virtual BOOL OnInitDialog();
    //}}AFX_VIRTUAL

    // Implementation
public:
    virtual ~CYRGroupTestWizardSheet();
    BOOL IsWizardMode()
    {
        return m_bWizardMode;
    }
    void OnWizardFinish();
    void GenerateScripts();

    CYRServer *m_pServer;
    // Generated message map functions
protected:
    //{{AFX_MSG(CYRGroupTestWizardSheet)
    // NOTE - the ClassWizard will add and remove member functions here.
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()

    void WriteTSS();
    BOOL CheckOutTest(const CString& strTest);
    BOOL CheckInTest(const CString& strTest);
    BOOL SetupWizard(const CString& strTest);

    CYRNameDefinitionPage m_NameDefPage;
    CYRGroupDependencyPage m_GroupDepPage;
    CYRSummaryPage m_SummaryPage;

    BOOL m_bWizardMode;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CYRGROUPTESTWIZARD_H__5EF718A7_03B7_11D4_BD87_00C04F89E392__INCLUDED_)
