//{{AFX_INCLUDES()
//}}AFX_INCLUDES
#if !defined(AFX_CECWEBEXECDLG_H__7E650B13_0F8B_11D4_A6C3_00500447FC27__INCLUDED_)
#define AFX_CECWEBEXECDLG_H__7E650B13_0F8B_11D4_A6C3_00500447FC27__INCLUDED_
/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CECWebExecDlg.h : header file
//

#include "resource.h"
//#include "GridClasses/GridCtrl.h"
#include "CECGridWnd.h"
/////////////////////////////////////////////////////////////////////////////
// CECWebExecDlg dialog
class CYRServer;
class CECWebExecDlg : public CDialog
{
    // Construction
public:
    CString GetTestToExecute();
    CECWebExecDlg(CString strProject, CString strTest, CWnd* pParent = NULL);   // standard constructor
    void EditStarted(int nRow, int nCol);
    void UpdateTotals(BOOL bRedraw = TRUE);
    BOOL GetNodeInfo(CString& physNode, CString& userName, CString& password);


    CString m_szTestToExecute;
    CString m_Project;
    CString m_szNodeFile;
    CString m_szHost;
    CString m_szUsername;
    CString m_szPassword;
    BOOL m_bExecuting;
    int m_nTotalRow;

    // Dialog Data
    //{{AFX_DATA(CECWebExecDlg)
    enum { IDD = IDD_WEBEXEC };
    CComboBox   m_TestCombo;
    CButton m_ApplyButton;
    CButton m_ExecButton;
    CSpinButtonCtrl m_SpinVUsers;
    CSpinButtonCtrl m_SpinInterval;
    CEdit   m_DescriptionCtrl;
    int     m_nInterval;
    int     m_UsersPerInterval;
    //}}AFX_DATA


    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CECWebExecDlg)
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

    // Implementation
protected:

    // Generated message map functions
    //{{AFX_MSG(CECWebExecDlg)
    virtual BOOL OnInitDialog();
    afx_msg void OnSize(UINT nType, int cx, int cy);
    afx_msg void OnPopupInsertRow();
    afx_msg void OnPopupDeleterow();
    afx_msg void OnPopupNewinjector();
    afx_msg void OnApply();
    afx_msg void OnChangeInterval();
    afx_msg void OnChangeUsers();
    afx_msg void OnExecute();
    virtual void OnCancel();
    afx_msg void OnSelchange();
    afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	afx_msg void OnAdvanced();
	//}}AFX_MSG
    DECLARE_MESSAGE_MAP()
private:
	BOOL m_bThreadPool;
    CString m_szHtmlHelpFile;

    BOOL NodeExists(CString nodeName);
    int m_nNumberOfTests;
    void ResetGrid();
    void LoadTestList();
    BOOL LoadTestParams();
    void StoreTestParams(BOOL bCompiled);
    CECGridWnd m_wndGrid;
    CString m_szDescription;
    int m_nTotalVUsers;
    bool m_bSimple;
    int m_nNextRow;
    int m_nNextCol;
    int m_nDispatchRow;
    int m_nLastDummyRow;
    CStringArray m_nodeArray;

    BOOL LoadTestInfo();
    CString CheckOutWizFile(CString strTestName, BOOL bLock = FALSE);
    CString GetTestDescription(CString wizFile);
    int GetSubTestCount(CString wizPath);
    CString GetSubTest(CString wizPath, int index);
    int GetVUsers(CString wizFile);
    void GetInjectorList();
    void AddTestColumn(CString strTest);
    int GetColForTest(CString strTest);
    BOOL WriteTssSimple(CString strTest, int ramp);
    void SetupControls(int nRow);
    BOOL ValidateGrid();
    void AddLoadColumn();
    void SetupBasicGrid();
    BOOL WriteTssGroup();
    BOOL Compile();

    CYRServer *m_pServer;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CECWEBEXECDLG_H__7E650B13_0F8B_11D4_A6C3_00500447FC27__INCLUDED_)
