/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

/////////////////////////////////////////////////////////////////////////
//
// CYRTGEnvironmentDlg.h
// ---------------------
//
//    This is the include file for the CYRTGEnvironmentDlg class
//
//=========================================================================
#if !defined(CYRTGEnvironmentDlg__INCLUDED_)
#define CYRTGEnvironmentDlg__INCLUDED_

//
//  PSL Macros.
//
extern "C"
{
#include "psl_macros.h"
#include "target_rtndef.h"  // Target/Executer routines
}


#include "resource.h"

class CYRTGEnvironmentDlg : public CDialog
{
    // Construction
public:
    CYRTGEnvironmentDlg(CWnd* pParent = NULL);   // standard constructor

    // Dialog Data
    //{{AFX_DATA(CYRTGEnvironmentDlg)
    enum { IDD = IDD_DATABASE_CONTEXT };
    CComboBox   m_NewContext;
    CString m_szStatic1;
    //}}AFX_DATA

    CString GetCurrentContext();
    void GetAvailableContexts(CString);
    void GetAvailableContextList(CStringArray* arAvailableContexts);

    void SetNewContext(CString);

    BOOL IsTargetSupported      (TARGETID Target, BOOL bAuthorized=TRUE);
    BOOL IsTargetSupported      (char* pTarget, BOOL bCheckAuthorized);


    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CYRTGEnvironmentDlg)
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

    // Implementation
protected:

    // Generated message map functions
    //{{AFX_MSG(CYRTGEnvironmentDlg)
    virtual BOOL OnInitDialog();
    virtual void OnOK();
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};
#endif
