/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#pragma warning (disable: 4786 4503 4511 4512 4663 4100 4018)

#include "CECFileList.h"
#include "mdbexcept.h"
///////////////////////////////////////////////////////////////////////////////
//@mfunc Constructor
CECFileList::CECFileList()
{}
///////////////////////////////////////////////////////////////////////////////
//@mfunc Destructor delete all file objects contained

CECFileList::~CECFileList()
{
    scriptfilemap_t::iterator iter;
    for(iter=m_scriptfilemap.begin();iter!=m_scriptfilemap.end();iter++)
    {
        delete (*iter).second;
    }
}
///////////////////////////////////////////////////////////////////////////////
//@mfunc Define a new file, check not already defined
//@parm  New fileid
int CECFileList::DefineFile(string fileid)
{
    scriptfilemap_t::iterator iter=m_scriptfilemap.find(fileid);
    if(iter!=m_scriptfilemap.end())
        throw mdbParseException(string("File ")+fileid+" Defined multiple times in Script");
    m_scriptfilemap.insert(scriptfilemap_t::value_type(fileid,new CECScriptFile(fileid)));
    return 0;
}
///////////////////////////////////////////////////////////////////////////////
//@mfunc Return FileObject for fileid
//@parm  Fileid
//@rdesc Associated file Object
CECScriptFile* CECFileList::GetFile(string fileid)
{
    scriptfilemap_t::iterator iter=m_scriptfilemap.find(fileid);
    if(iter==m_scriptfilemap.end())
        throw mdbParseException(string("File ")+fileid+" UnDefined in Script");
    return (*iter).second;
}
