/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

///////////////////////////////////////////////////////////////////////////////
// @doc     CECResultsFile
// @module  CECResultsFile | File Access class
///////////////////////////////////////////////////////////////////////////////

#ifdef WIN32
#pragma warning(disable:4786)
#pragma warning(disable:4503)
#endif

#ifndef _CECSCRIPTFILE_H_
#define _CECSCRIPTFILE_H_

#ifndef CYRANO_TP_STANDALONE
#include "CyrWrapLib/CyrWrapLib.h"
#include "CyrImpactLib/CECImpactFolders.h"
#include "CyrImpactLib/CECImpactProject.h"


#include <list>
#include <string>
#include <fstream>

#ifndef _VMS
using std::string;
using std::list;
using std::fstream;
#endif

#include "tofprmdef.h"


class CECResultsFile
{
public:
    CECResultsFile(CECOrbFolder*,const char*,const char*);

    virtual ~CECResultsFile();
    virtual void Store(bool del = true);
    virtual string GetFileName()
    {
        return m_FileName;
    };
    virtual string GetFullFileName()
    {
        return m_FullFileName;
    };
#ifndef TH_POOL_VER
    void Concatenate();
#endif // TH_POOL_VER

private:
    string m_FileName;
    string m_FullFileName;

    CECOrbFile* m_OrbFile;

};
#endif
#endif
