/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// mdb_statetext return the text corresponding to
// thread status and phases

#include "mdbstatus.h"


const char * mdb_stext(int code)
{

    switch(code)
    {
    case MDB_OK:
        return(MDB_OK_TXT);
        break;
    case MDB_FAIL:
        return(MDB_FAIL_TXT);
        break;
    case MDB_EOF:
        return(MDB_EOF_TXT);
        break;
    case MDB_NULLNAME:
        return(MDB_NULLNAME_TXT);
        break;
    case MDB_FNF:
        return(MDB_FNF_TXT);
        break;
    case MDB_PEND:
        return(MDB_PEND_TXT);
        break;
    case MDB_DONE:
        return(MDB_DONE_TXT);
        break;
    case MDB_RESDONE:
        return(MDB_RESDONE_TXT);
        break;
    case MDB_CANCEL:
        return(MDB_CANCEL_TXT);
        break;
    case MDB_START:
        return(MDB_START_TXT);
        break;
    case MDB_FAILDONE:
        return(MDB_FAILDONE_TXT);
        break;
    case MDB_SLEEP:
        return(MDB_SLEEP_TXT);
        break;
    case MDB_ABORT:
        return(MDB_ABORT_TXT);
        break;
    case MDB_COMPLETE:
        return(MDB_COMPLETE_TXT);
        break;
    case MDB_IDLE:
        return(MDB_IDLE_TXT);
        break;
    case MDB_VWAIT:
        return(MDB_VWAIT_TXT);
        break;
    case MDB_SWAIT:
        return(MDB_SWAIT_TXT);
        break;
    case MDB_FOWAIT:
        return(MDB_FOWAIT_TXT);
        break;
    case MDB_FCWAIT:
        return(MDB_FCWAIT_TXT);
        break;
    case MDB_TSWAIT:
        return(MDB_TSWAIT_TXT);
        break;
    case MDB_TEWAIT:
        return(MDB_TEWAIT_TXT);
        break;
    case MDB_WMWAIT:
        return(MDB_WMWAIT_TXT);
        break;
    case MDB_SCWAIT:
        return(MDB_SCWAIT_TXT);
        break;
    case MDB_VSWAIT:
        return(MDB_VSWAIT_TXT);
        break;
    case MDB_DELAY:
        return(MDB_DELAY_TXT);
        break;
    case MDB_SRSIG:
        return(MDB_SRSIG_TXT);
        break;
    case MDB_VRSIG:
        return(MDB_VRSIG_TXT);
        break;
    case MDB_ABORTING:
        return(MDB_ABORT_TXT);
        break;
    case MDB_EXCEPT:
        return(MDB_EXCEPT_TXT);
        break;
    default:
        return("No Description");
        break;
    }
    return("ERROR");
}

const char * mdb_ptext(int code)
{

    switch(code)
    {
    case PHASE_NONE:
        return(PHASE_NONE_TXT);
        break;
    case LOGIN_CONNECT:
        return(LOGIN_CONNECT_TXT);
        break;
    case LOGIN_CHECK:
        return(LOGIN_CHECK_TXT);
        break;
    case LOGOUT_DISCONNECT:
        return(LOGOUT_DISCONNECT_TXT);
        break;
    case LOGOUT_CHECK:
        return(LOGOUT_CHECK_TXT);
        break;
    case LANGCMD_SEND_PREP:
        return(LANGCMD_SEND_PREP_TXT);
        break;
    case LANGCMD_SEND:
        return(LANGCMD_SEND_TXT);
        break;
    case LANGCMD_SEND_CHECK:
        return(LANGCMD_SEND_CHECK_TXT);
        break;
    case LANGCMD_PARSE:
        return(LANGCMD_PARSE_TXT);
        break;
    case LANGCMD_PARSE_CHECK:
        return(LANGCMD_PARSE_CHECK_TXT);
        break;
    case RESULTS:
        return(RESULTS_TXT);
        break;
    case RESULTS_CHECK:
        return(RESULTS_CHECK_TXT);
        break;
    case FETCH:
        return(FETCH_TXT);
        break;
    case FETCH_CHECK:
        return(FETCH_CHECK_TXT);
        break;
    case CONABORT:
        return(CONABORT_TXT);
        break;
    case CONABORT_CANCEL_CHECK:
        return(CONABORT_CANCEL_CHECK_TXT);
        break;
    case CONABORT_CLOSE:
        return(CONABORT_CLOSE_TXT);
        break;
    case CONABORT_CLOSE_CHECK:
        return(CONABORT_CLOSE_CHECK_TXT);
        break;
    default:
        return("No Description");
        break;
    }
    return("ERROR");
}
