/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/
#ifndef _CECSemaphore_H_
#define _CECSemaphore_H_
///////////////////////////////////////////////////////////////////////////////
// @doc     CECSemaphore
// @module  CECSemaphore|wrapper class for cross-process/node Semaphores, these are
//      CYRANO-Test type semaphores
///////////////////////////////////////////////////////////////////////////////
#include <OSTAORB/OSTAORB.h>
#include "CORBARepository.h"
#include "TMVarFactory.h"
#include "TPCYRSemaphore.h"
#include "tofprmdef.h"
class CECSemaphore
{
public:
    CECSemaphore(string name,int scope);
    virtual ~CECSemaphore();
    virtual bool acquire();
    virtual bool release();
    virtual bool tryacquire();
private:
    TPSemaphore_var m_Semaphore;
};
#endif
