/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/
#include "CECArrayVar.h"
CECArrayVar::CECArrayVar(string name,int size,int options,string indecies):CECProcessVar(options,name)
{
    _size=size;
    //Call Helper Method in CECVar
    unsigned long value_list_size=ParseIndecies(indecies,&min_index,&max_index,&size_index);
    value_list.reserve(value_list_size);//Set size of array
    string def_value="";
    if(_options & VTINT )def_value="0";//set default value to literal '0'
    value_list.insert(value_list.end(),value_list_size,def_value);
}
CECArrayVar::~CECArrayVar()
{}

string  CECArrayVar::get_value(const string& expression)
{
    string retstr;
    long index;
    index=GetIndexValue(expression,min_index,max_index,size_index);//This does not lock the mutex because recursive indecies could result in deadlock
    retstr=value_list[index];
    return retstr;
}
int CECArrayVar::set_value(const string& newval,const string& expression)
{
    vector<string>::size_type index;
    index=GetIndexValue(expression,min_index,max_index,size_index);
    value_list[index]=newval;
    return 0;
}

