/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#ifndef __LOG_TRACE__
#define __LOG_TRACE__

#include "Trace.hpp"

// Temporary class used to merge former PLog logging mechanism with the new CTrace one.
class CLogTrace
{
public:
    CLogTrace(CTrace* pTrace = NULL)
        : m_pTrace(pTrace) {}

    void AddTrace(const char* category, long level, const char* msg, ...)
    {
        if(m_pTrace)
        {
            const char *str = msg;

	        va_list argList;
	        va_start(argList, msg);
            while(str != NULL)
            {
                m_pTrace->TraceIf(category, str, TRUE);
                str = va_arg(argList, char*);
            }
	        va_end(argList);
        }
    }

    void AddTrace(const char* category, long level, const char* msg)
    {
        if(m_pTrace)
        {
            m_pTrace->TraceIf(category, msg, TRUE);
        }
    }

/*    void Store(CECOrbFolder* pFolder)
    {
        assert(0);
        // TODO.
    }
*/
private:
    CTrace  *m_pTrace;
};

#endif