/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

///////////////////////////////////////////////////////////////////////////////////////
//
// Specialisations of some of PString's templates for CDataBuffListAccessor and 
// CDataBuffListChunkAccessor.
//
///////////////////////////////////////////////////////////////////////////////////////

#include <string>
#include "MemoryBufferHandler.hpp"

// TODO: devrait recevoir un 'const CDataBuffListAccessor &' en entre.
inline std::string& MakeString<CDataBuffListAccessor>(CDataBuffListAccessor strIn, unsigned long ulLen, std::string& strOut)
{
    strIn.BuildString(strOut, ulLen);
    return strOut;
}

inline std::string& MakeString<CDataBuffListChunkAccessor>(CDataBuffListChunkAccessor strIn, unsigned long ulLen, std::string& strOut)
{
    strIn.BuildString(strOut, ulLen);
    return strOut;
}

template <>
inline CDataBuffListAccessor FindString<CDataBuffListAccessor>( CDataBuffListAccessor pContainer, 
                                                                CDataBuffListAccessor pContainerEnd, 
                                                                unsigned long ulContainerSize,
                                                                const char* pcSubString, 
                                                                unsigned long ulSubStringSize, 
                                                                BOOL bCaseSensitive,
                                                                CDataBuffListAccessor& pAfterSubString)
{
    CDataBuffListAccessor beg = pContainer;

    // TODO: optimiser en utilisant CDataBuffListBaseAccessor<CdBLA>::BOOL FindString(...) ?
    if(beg.MoveToStr(pcSubString, ulSubStringSize, bCaseSensitive) == TRUE)
    {
        pAfterSubString = beg;
        pAfterSubString += ulSubStringSize;

        assert(beg - pContainer <= ulContainerSize);

        return beg;
    }
    else
        return CDataBuffListAccessor(NULL);
}

template <>
inline CDataBuffListChunkAccessor FindString<CDataBuffListChunkAccessor>(CDataBuffListChunkAccessor pContainer, 
                                                                CDataBuffListChunkAccessor pContainerEnd, 
                                                                unsigned long ulContainerSize,
                                                                const char* pcSubString, 
                                                                unsigned long ulSubStringSize, 
                                                                BOOL bCaseSensitive,
                                                                CDataBuffListChunkAccessor& pAfterSubString)
{
    CDataBuffListChunkAccessor beg = pContainer;

    if(beg.MoveToStr(pcSubString, ulSubStringSize, bCaseSensitive) == TRUE)
    {
        pAfterSubString = beg;
        pAfterSubString += ulSubStringSize;

        return beg;
    }
    else
        return CDataBuffListChunkAccessor(NULL);
}
