/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#ifndef _TMTHREADCONTROL_H_
#define _TMTHREADCONTROL_H_
///////////////////////////////////////////////////////////////////////////////
// @doc     TMthreadcontrol
// @module  TMthreadcontrol | Derived threadcontrol class for TestManagers
///////////////////////////////////////////////////////////////////////////////
#include "threadcontrol.h"
#include "TMThread.h"
#include "CORBARepository.h"
#include <cassert>

class TMthreadcontrol:public Cthreadcontrol
{
public:
    // Constructor/Destructor
TMthreadcontrol(TScriptRule* rule):Cthreadcontrol(rule)
    {
        InitTMThread();
    };
TMthreadcontrol(TScriptRule* rule, int max_threads):Cthreadcontrol(rule,max_threads)
    {
        InitTMThread();
    };
    void InitTMThread()
    {
        //Initialise TMThread Static Members
        if(!TMThread::thrule)TMThread::thrule=new TScriptRule("ThreadDefinition.odl");
        if(!TMThread::ThreadCache)TMThread::ThreadCache=new ScriptCache(TMThread::thrule);
    };
    virtual ~TMthreadcontrol()
    {
        //delete TMThread Static Members
        if(TMThread::thrule)
            delete TMThread::thrule;
        if(TMThread::ThreadCache)
            delete TMThread::ThreadCache;
    };
    virtual int AttachThread(const char* TofFile,TestLevel_ptr pTL=TestLevel::_nil(),TestManager_ptr TM=TestManager::_nil())
    {
        string message = TofFile;
        Repository->LogMessage(message.c_str(), AUDITMSG);
        // connect thread to execute file
        TMThread* ptr_thread=new TMThread(this,message);
        assert(ptr_thread);
        threads.push_back(ptr_thread);
        if(ptr_thread==NULL)return -1;
        ptr_thread->SetThreadInfo(pTL,TM);
        ptr_thread->ActivateThread();
        return 0;
    }// End of AttachThread
}
;
#endif
