#ifndef PSL__PSLERR_PRMDEF_LOADED
#define PSL__PSLERR_PRMDEF_LOADED 1
/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

/*===========================================================================*/
/*                                       */
/*               **** C O M M O N ****                   */
/*                                       */
/*===========================================================================*/
/*                                       */
/*          Module Name: PSLERR_PRMDEF               */
/*          ============                         */
/*                                       */
/* Description:                                  */
/* ============                                  */
/*                                       */
/*  Symbolic Names for Parameters to Error Trapping Routines         */
/*                                       */
/*                                       */
/*===========================================================================*/

/*** MODULE PSLERR_PRMDEF ***/

/*  Error classes */
#define            PSLERRCLS_NONE 0 /* No error has occurred */
#define            PSLERRCLS_EXCEPT 1   /* Exception Errors */
#define            PSLERRCLS_TRM 2  /* TRM Routines */
#define            PSLERRCLS_FDR 3  /* FDR Routines */
#define            PSLERRCLS_SCR 4  /* SCR Routines */
#define            PSLERRCLS_LIST 5 /* Listing Routines */
#define            PSLERRCLS_USER1 6    /* User Class 1 */
#define            PSLERRCLS_USER2 7    /* User Class 2 */
#define            PSLERRCLS_USER3 8    /* User Class 3 */
#define            PSLERRCLS_USER4 9    /* User Class 4 */
#define            PSLERRCLS_USER5 10   /* User Class 5 */
#define            PSLERRCLS_CTM 11 /* CTM Routines     */
#define            PSLERRCLS_MSGF 12    /* MSGF Routines    */
#define            PSLERRCLS_CMD 13 /* Command Line Parsing Routines */

#define            PSLERRCLS_VRF 14 /* VRF routines     */
#define            PSLERRCLS_MAX 14 /* Maximum Valid Value */


/*  Error responses/actions */
#define            PSLERRACT_RESERVED 0
/* Not used (helps catch errors) */
#define            PSLERRACT_RETURN 1
/* Return error status to caller */
/*  (Caller must handle the error) */
#define            PSLERRACT_REPORT 2
/* Report error and return to caller */
#define            PSLERRACT_JUMP 3
/* Use longjmp to unwind stack and */
/*  invoke error handler */
#define            PSLERRACT_REPJMP 4
/* Report error then PSLERRACT_JUMP */
#define            PSLERRACT_CALL 5
/* Call user's error handler */
#define            PSLERRACT_EXIT 6
/* Report error then exit */


/*  End of C Include File */

#endif  /* PSL__PSLERR_PRMDEF_LOADED */
